unit Surfaces2D;
{ Unit de trac de surfaces 2D }
{ Dcrt STABLE par F. OTT, le 28.10.2000 }
{ A FAIRE }
{ Xmin et Xmax ne sont definis nulle part mais sont disponibles en tant que variables ?!?!? }
{ bug au dpart si les facteurs d'challes ne sont pas dfinis                        }
{ Fixer le fonctionnement des curseurs                                                 }
{ donner la possibilit de se dplacer avec le curseur (plus fin)                      }
{ *** Coupe en "diagonale" ***                                                         }
{ EDOUARD: dans la combo, proposer sommes entre curseurs et sommes circulaires         }
{ bouton pour "rescaler" les data sur la palette                                       }
{ Amliorer les modif dynamiques de la palette                                         }
{ optimiser l'affichage des echelles sur le graph1D                                    }
{ amliorer les initialisations (definir les facteurs d'echelle                        }
{ EN STOCK: on a une fenetre "loupe" sympa                                             }
{ EN STOCK: on a une fenetre pour superposer des bitmaps                               }
{           sera utile si on veut faire des masques ou comparer dex figures            }
{ MODIFICATIONS                                                                        }
{ le 29.10.00                                                                          }

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  Menus, ExtCtrls, JPeg, ExtDlgs, StdCtrls, G32, G32_Bytemaps, G32_Image, G32_Layers,
  G32_RangeBars, G32_Filters, G32_Transforms, G32_Polygons, EditReal, xyGraph;

const
     coupeHorz1 = 1; { indices des graphes pour les diffrentes coupes }
     coupeVert1 = 2;
     coupeHorz2 = 3;
     coupeVert2 = 4;
     coupeDiagX  = 5;
     coupeDiagY  = 6;
     coupeDiagP45  = 7;
     coupeDiagM45  = 8;

type Tableau3D=array of array of double;

type
  TSurfaces2Dform = class(TForm)
    SidePanel: TPanel;
    MainMenu: TMainMenu;
    mnFileNew: TMenuItem;
    mnFile: TMenuItem;
    mnFileOpen: TMenuItem;
    mnLayers: TMenuItem;
    mnNewBitmapLayer: TMenuItem;
    mnDelete: TMenuItem;
    OpenPictureDialog1: TOpenPictureDialog;
    pnlImage: TPanel;
    ScaleCombo: TComboBox;
    Label1: TLabel;
    Panel2: TPanel;
    ImageInterpolate: TCheckBox;
    mnNewBitmapRGBA: TMenuItem;
    mnNewCustomLayer: TMenuItem;
    mnMagnifier: TMenuItem;
    SaveDialog1: TSaveDialog;
    mnSimpleDrawing: TMenuItem;
    mnArrange: TMenuItem;
    mnBringFront: TMenuItem;
    mnSendBack: TMenuItem;
    N1: TMenuItem;
    mnLevelUp: TMenuItem;
    mnLevelDown: TMenuItem;
    N2: TMenuItem;
    N3: TMenuItem;
    mnScaled: TMenuItem;
    Replot1: TMenuItem;
    PaletteCombo: TComboBox;
    ScaleBar: TGaugeBar;
    StretchButton: TButton;
    PnlPos: TPanel;
    Panel5: TPanel;
    Xpos1: TEditReal;
    Xpos2: TEditReal;
    Label6: TLabel;
    Label7: TLabel;
    Panel1: TPanel;
    ImgView: TImgView32;
    XYcoupe: TxyGraph;
    PaletteCenterGaugeBar: TGaugeBar;
    PaletteAmplitudeGaugeBar: TGaugeBar;
    Trash1: TMenuItem;
    CreateData3D1: TMenuItem;
    TypeGraphCombo: TComboBox;
    Ypos2: TEditReal;
    Ypos1: TEditReal; 
    Label8: TLabel;
    Zval1: TEditReal;
    Zval2: TEditReal;
    ZmaxBox: TEditReal;
    ZminBox: TEditReal;
    Label9: TLabel;
    ZlogCheckBox: TCheckBox;
    Panel3: TPanel;
    Label4: TLabel;
    Panel4: TPanel;
    Z1DMinBox: TEditReal;
    Z1DMaxBox: TEditReal;
    Z1DLogCheckBox: TCheckBox;
    AutoScaleButton: TButton;
    Panel6: TPanel;
    Panel7: TPanel;
    ComboBoxDataSet: TComboBox;
    SaveMenu: TMenuItem;
    Close1: TMenuItem;
    SavePictureDialog: TSavePictureDialog;
    ColorScale: TImage32;
    scale5: TLabel;
    scale1: TLabel;
    scale2: TLabel;
    scale3: TLabel;
    scale4: TLabel;
    procedure mnFileNewClick(Sender: TObject);
    procedure ScaleComboChange(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure mnLayersClick(Sender: TObject);
    procedure ImageInterpolateClick(Sender: TObject);
    procedure ImgViewPaintStage(Sender: TObject; StageNum: Cardinal);
    procedure FormCreate(Sender: TObject);
    procedure ImgViewMouseDown(Sender: TObject; Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
    procedure MagnChange(Sender: TObject);
    procedure Replot;
    procedure Replot1Click(Sender: TObject);
    procedure PaletteComboChange(Sender: TObject);
    procedure ScaleBarChange(Sender: TObject);
    procedure Stretch;
    procedure StretchButtonClick(Sender: TObject);
    procedure PaletteCenterGaugeBarChange(Sender: TObject);
    procedure PaletteAmplitudeGaugeBarChange(Sender: TObject);
    procedure CreateData3D1Click(Sender: TObject);
    procedure Zval1Change(Sender: TObject);
    procedure TypeGraphComboChange(Sender: TObject);
    procedure ZminBoxExit(Sender: TObject);
    procedure ZmaxBoxExit(Sender: TObject);
    procedure ZlogCheckBoxClick(Sender: TObject);
    procedure ZmaxBoxKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure ZminBoxKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure AutoScaleButtonClick(Sender: TObject);
    procedure Z1DMinBoxKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure Z1DMaxBoxKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure Z1DLogCheckBoxClick(Sender: TObject);
    procedure ComboBoxDataSetChange(Sender: TObject);
    procedure SaveMenuClick(Sender: TObject);
  private
    FSelection: TPositionedLayer;
    procedure WMEraseBkgnd(var Msg: TMessage); message WM_ERASEBKGND;
  protected
    RBLayer: TRubberbandLayer;
    procedure RBMouseDown(Sender: TObject; Buttons: TMouseButton; Shift: TShiftState; X, Y: Integer);
  public
    CurrentScale:double;
    CurrentX,CurrentY:integer;
    Xcursor1, Ycursor1, Xcursor2, Ycursor2:integer; { positions des curseurs 1 et 2 }
    MesData3D, Data3D_NP, Data3D_UU, Data3D_DD:Tableau3D;
    Xmesh,Ymesh:integer;
    xmin,xmax,ymin,ymax:double;
    Zmin,Zmax:double;
    DataSet: TByteMap;
    ColorBar:TByteMap; { barre de couleurs pour savoir quoi est quoi }
    palGrayscale: TPalette32;
    palGreens: TPalette32;
    palReds: TPalette32;
    palRainbow: TPalette32;
    palCustom:Tpalette32;
    { variables polygones }
    PolygonH1, PolygonV1, PolygonH2, PolygonV2, PolygonD: TPolygon32;
    BitmapList: TBitmap32List; { quoi qu'est ce ??? }
    procedure GenPalettes;
    procedure GenSampleData(W, H: Integer);
    procedure PaintData;

    procedure CreateNewImage(AWidth, AHeight: Integer; FillColor: TColor32);
    { trac des polygones }
    procedure draw;
    procedure UpdateCourbesAafficher;
  end;

var
  Surfaces2Dform: TSurfaces2Dform;

implementation

uses NewImageUnit, RGBALoaderUnit, Math;

{$R *.DFM}

{ TForm1 }

procedure TSurfaces2Dform.GenPalettes;
var
  i: Integer;
  f: Single;
begin
  for i := 0 to 255 do
  begin
    f := i / 255;
    palGrayscale[i] := HSLtoRGB(0, 0, f * 0.9 + 0.1);
    palGreens[i] := HSLtoRGB(f * 0.4, 0.5, f * 0.4 + 0.2);
    palReds[i] := HSLtoRGB(0.8 + f * 0.3 , 0.7 + f * 0.3, f * 0.85 + 0.1);
    palRainbow[i] := HSLtoRGB(f * 1.2, 0.6, f * 0.8 + 0.2);
    PalCustom[i]:= HSLtoRGB(0, 0, PaletteAmplitudeGaugeBar.position/100 * f + PaletteCenterGaugeBar.position/100);
  end;
end;

procedure TSurfaces2Dform.GenSampleData(W, H: Integer);
var
  i, j: Integer;
  aux,aux1:double;

  function Clamp(FloatVal: Extended): Byte;
  begin
    if FloatVal <= 0 then Result := 0
    else if FloatVal >= 1 then Result := 255
    else Result := Round(FloatVal * 255);
  end;

begin
if ZlogCheckBox.checked=false
then begin
     aux:=Zmax-Zmin;
     DataSet.SetSize(W, H);
     for j := 0 to H - 1 do
         for i := 0 to W - 1 do
         begin
         // just some noise
         DataSet[i, j] := Clamp((MesData3D[i,j]-Zmin)/aux);
         end;
     end
else begin
     aux:=Log10(Zmax)-Log10(Zmin);
     DataSet.SetSize(W, H);
     for j := 0 to H - 1 do
         for i := 0 to W - 1 do
         begin
         // just some noise
         aux1:=MesData3D[i,j];
         if aux1>0
         then DataSet[i, j] := Clamp((log10(aux1)-log10(zmin))/aux)
         else DataSet[i, j] := 0;
         end;
     end
end;

procedure TSurfaces2Dform.CreateNewImage(AWidth, AHeight: Integer; FillColor: TColor32);
begin
  with ImgView do
  begin
    RBLayer := nil;
    Layers.Clear;
    Scale := 1;
    Bitmap.SetSize(AWidth, AHeight);
    Bitmap.Clear(FillColor);
    pnlImage.Visible := not Bitmap.Empty;
  end;
end;


procedure TSurfaces2Dform.FormCreate(Sender: TObject);
var i:integer;
begin
  ColorBar := TByteMap.Create;
  ColorBar.setSize(1,256);
  for i:=0 to 255 do ColorBar[0,i]:=255-i; { echelle lineaire }
  ColorScale.ScaleMode := SmStretch;   { ne fonctionne pas en ImgView32 ?!? }
  // by default, PST_CLEAR_BACKGND is executed at this stage,
  // which, in turn, calls ExecClearBackgnd method of ImgView.
  // Here I substitute PST_CLEAR_BACKGND with PST_CUSTOM, so force ImgView
  // to call the OnPaintStage event instead of performing default action.
  with ImgView.PaintStages[0]^ do
  begin
    if Stage = PST_CLEAR_BACKGND then Stage := PST_CUSTOM;
  end;
  { rajout de F. OTT }
  { on introduit une palette et une image Bitmap }
  PaletteCombo.ItemIndex := 3; { on se met en rainbow par defaut }
  GenPalettes;
  DataSet := TByteMap.Create;
  { cration des curseurs }
  PolygonH1 := TPolygon32.Create;
  PolygonV1 := TPolygon32.Create;
  PolygonH2 := TPolygon32.Create;
  PolygonV2 := TPolygon32.Create;
  PolygonD := TPolygon32.Create;
{ echelles pour le graph 2D }
  zmin:=zminbox.value;zmax:=zmaxbox.value;
{ echelles pour le mini graph 1D }
  XYcoupe.YAxis.min:=Z1DMinbox.value;
  XYcoupe.YAxis.max:=Z1DMaxbox.value;
  XYcoupe.YAxis.Logscale:=true;

  UpdateCourbesAafficher;
end;

procedure TSurfaces2Dform.FormDestroy(Sender: TObject);
begin
  RBLayer := nil;
  DataSet.Free;
  { destruction des polygones }
  PolygonH1.Free;PolygonV1.Free;
  PolygonH2.Free;PolygonV2.Free;
  PolygonD.Free;
end;

procedure TSurfaces2Dform.ImageInterpolateClick(Sender: TObject);
const
  STRETCH_FILTER: array [Boolean] of TStretchFilter = (sfNearest, sfLinear);
begin
  ImgView.Bitmap.StretchFilter := STRETCH_FILTER[ImageInterpolate.Checked];
end;

procedure TSurfaces2Dform.ImgViewMouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
var largeur,hauteur:double;
    i,aux:integer;
    deltax,deltay:double;
    H,V:TFixedPoint;
begin
  { conversion d'une position en pixel vers une position en absolue du graph }
  { on suppose que le bitmap est toujours centr sur la fenetre ImgView      }
  { Taille de la fenetre graphique                                           }
  largeur:=abs(ImgView.GetViewPortRect.Left-ImgView.GetViewPortRect.Right);
  hauteur:=abs(ImgView.GetViewPortRect.Top-ImgView.GetViewPortRect.Bottom);
  { trac des coupes sur le graph 2D }
  { achtung, on n'a pas le dernier point ?!?! }
  { il faudrait avoir une matrice de taille Xmesh+1 }
  deltax:=(xmax-xmin)/Xmesh;
  deltay:=(ymax-ymin)/Ymesh;
  { on purge tous les graph }
  if Button = mbLeft then { si boutton souris gauche }
  begin
  Xpos1.value:=(Xmesh/2)+(X-largeur/2)/CurrentScale;
  Ypos1.value:=(Ymesh/2)+(Y-hauteur/2)/CurrentScale;
  CurrentX:=Floor(Xpos1.value);XCursor1:=CurrentX;
  CurrentY:=Floor(Ypos1.value);YCursor1:=CurrentY;
     xyCoupe[CoupeHorz1].clear;xyCoupe[CoupeHorz1].holdupdates:=true;
     For i:=0 to Xmesh-1 do xyCoupe[CoupeHorz1][xmin+deltax*i]:=MesData3D[i,CurrentY];
     xyCoupe[CoupeHorz1].holdupdates:=false;
     xyCoupe[CoupeVert1].clear;xyCoupe[CoupeVert1].holdupdates:=true;
     For i:=0 to Ymesh-1 do xyCoupe[CoupeVert1][ymin+deltay*i]:=MesData3D[CurrentX,i];
     xyCoupe[CoupeVert1].holdupdates:=false;
  Zval1.value:=MesData3D[CurrentX,CurrentY];
  end;
  if Button = mbRight then { si boutton souris gauche }
  begin
  Xpos2.value:=(Xmesh/2)+(X-largeur/2)/CurrentScale;
  Ypos2.value:=(Ymesh/2)+(Y-hauteur/2)/CurrentScale;
  CurrentX:=Floor(Xpos2.value);XCursor2:=CurrentX;
  CurrentY:=Floor(Ypos2.value);YCursor2:=CurrentY;
     xyCoupe[CoupeHorz2].clear;xyCoupe[CoupeHorz2].holdupdates:=true;
     For i:=0 to Xmesh-1 do xyCoupe[CoupeHorz2][xmin+deltax*i]:=MesData3D[i,CurrentY];
     xyCoupe[CoupeHorz2].holdupdates:=false;
     xyCoupe[CoupeVert2].clear;xyCoupe[CoupeVert2].holdupdates:=true;
     For i:=0 to Ymesh-1 do xyCoupe[CoupeVert2][ymin+deltay*i]:=MesData3D[CurrentX,i];
     xyCoupe[CoupeVert2].holdupdates:=false;
  Zval2.value:=MesData3D[CurrentX,CurrentY];
  end;
  { calcul de la coupe en diagonaleX de l'image }
  if (typeGraphCombo.text='DiagonaleX') or (typeGraphCombo.text='DiagonaleY') then
  begin
  xyCoupe[CoupeDiagX].clear;xyCoupe[CoupeDiagX].holdupdates:=true;
  if abs(Xcursor2-Xcursor1)>abs(Ycursor2-Ycursor1)
  then if Xcursor2>Xcursor1
       then For i:=Xcursor1 to Xcursor2 do
            begin aux:=round(Ycursor1+(Ycursor2-Ycursor1)*(i-Xcursor1)/(Xcursor2-Xcursor1));
                  xyCoupe[CoupeDiagX][i]:=MesData3D[i,aux] end
       else For i:=Xcursor2 to Xcursor1 do
            begin aux:=round(Ycursor2+(Ycursor1-Ycursor2)*(i-Xcursor2)/(Xcursor1-Xcursor2));
                  xyCoupe[CoupeDiagX][i]:=MesData3D[i,aux] end
  else if Ycursor2>Ycursor1
       then For i:=Ycursor1 to Ycursor2 do
            begin aux:=round(Xcursor1+(Xcursor2-Xcursor1)*(i-Ycursor1)/(Ycursor2-Ycursor1));
                  xyCoupe[CoupeDiagX][aux]:=MesData3D[aux,i] end
       else For i:=Ycursor2 to Ycursor1 do
            begin aux:=round(Xcursor2+(Xcursor1-Xcursor2)*(i-Ycursor2)/(Ycursor1-Ycursor2));
                  xyCoupe[CoupeDiagX][aux]:=MesData3D[aux,i] end;
  xyCoupe[CoupeDiagX].holdupdates:=false;
  { calcul de la coupe en diagonaleY de l'image }
  xyCoupe[CoupeDiagY].clear;xyCoupe[CoupeDiagY].holdupdates:=true;
  if abs(Xcursor2-Xcursor1)>abs(Ycursor2-Ycursor1)
  then if Xcursor2>Xcursor1
       then For i:=Xcursor1 to Xcursor2 do
            begin aux:=round(Ycursor1+(Ycursor2-Ycursor1)*(i-Xcursor1)/(Xcursor2-Xcursor1));
                  xyCoupe[CoupeDiagY][aux]:=MesData3D[i,aux] end
       else For i:=Xcursor2 to Xcursor1 do
            begin aux:=round(Ycursor2+(Ycursor1-Ycursor2)*(i-Xcursor2)/(Xcursor1-Xcursor2));
                  xyCoupe[CoupeDiagY][aux]:=MesData3D[i,aux] end
  else if Ycursor2>Ycursor1
       then For i:=Ycursor1 to Ycursor2 do
            begin aux:=round(Xcursor1+(Xcursor2-Xcursor1)*(i-Ycursor1)/(Ycursor2-Ycursor1));
                  xyCoupe[CoupeDiagY][i]:=MesData3D[aux,i] end
       else For i:=Ycursor2 to Ycursor1 do
            begin aux:=round(Xcursor2+(Xcursor1-Xcursor2)*(i-Ycursor2)/(Ycursor1-Ycursor2));
                  xyCoupe[CoupeDiagY][i]:=MesData3D[aux,i] end;
  xyCoupe[CoupeDiagY].holdupdates:=false;
  end;

  { calcul de la coupe en diagonale  45 de l'image }
  if (typeGraphCombo.text='Diagonale +45') or (typeGraphCombo.text='Diagonale -45') then
  begin
  xyCoupe[CoupeDiagP45].clear;xyCoupe[CoupeDiagP45].holdupdates:=true;
  xyCoupe[CoupeDiagM45].clear;xyCoupe[CoupeDiagM45].holdupdates:=true;
  for i:=0 to Xmesh-1 do
  begin
       aux:=round(Ycursor1-1*(i-Xcursor1)); { pente de -1 }
       if (aux>=0) and (aux<Ymesh) then xyCoupe[CoupeDiagP45][i]:=MesData3D[i,aux];
       aux:=round(Ycursor1+1*(i-Xcursor1)); { pente de +1 }
       if (aux>=0) and (aux<Ymesh) then xyCoupe[CoupeDiagM45][i]:=MesData3D[i,aux];
  end;
  xyCoupe[CoupeDiagP45].holdupdates:=false;xyCoupe[CoupeDiagM45].holdupdates:=false;
  end;

  { essai de trac de polygones sur l'image }
  if Button = mbLeft then
  begin
  PolygonH1.Clear;{PolygonH.newline; }
  PolygonH1.Add(FixedPoint(0, CurrentY));PolygonH1.Add(FixedPoint(Xmesh+100, CurrentY));
  PolygonV1.Clear;{PolygonH.newline; }
  PolygonV1.Add(FixedPoint(CurrentX, 0));PolygonV1.Add(FixedPoint(CurrentX, Ymesh+100));
  end;
  if Button = mbRight then
  begin
  PolygonH2.Clear;{PolygonH.newline; }
  PolygonH2.Add(FixedPoint(0, CurrentY));PolygonH2.Add(FixedPoint(Xmesh+2, CurrentY));
  PolygonV2.Clear;{PolygonH.newline; }
  PolygonV2.Add(FixedPoint(CurrentX, 0));PolygonV2.Add(FixedPoint(CurrentX, Ymesh+2));
  end;
  PolygonD.Clear;
  { cration de la coupe en diagonale }
  if (typeGraphCombo.text='DiagonaleX') or (typeGraphCombo.text='DiagonaleY') then
  begin PolygonD.Add(FixedPoint(Xcursor1,Ycursor1));PolygonD.Add(FixedPoint(Xcursor2,Ycursor2));  end;
  draw;
end;

procedure TSurfaces2Dform.ImgViewPaintStage(Sender: TObject; StageNum: Cardinal);
var
  I, J: Integer;
  P: PColor32;
  OddY: Boolean;
begin
  with ImgView.Buffer do
  begin
    P := Pointer(Bits);
    for J := 0 to Height - 1 do
    begin
      OddY := Odd(J shr 3);
      for I := 0 to Width - 1 do
      begin
        if Odd(I shr 3) = OddY then P^ := $FFFFFFFF
        else P^ := $FFB0B0B0;
        Inc(P);
      end;
    end;
  end;
end;


procedure TSurfaces2Dform.MagnChange(Sender: TObject);
begin
  ImgView.Invalidate;
end;


procedure TSurfaces2Dform.mnFileNewClick(Sender: TObject);
begin
  with NewImageForm do
  begin
    ShowModal;
    if ModalResult = mrOK then
      CreateNewImage(UpDown1.Position, UpDown2.Position, Color32(Panel1.Color));
  end;
end;



procedure TSurfaces2Dform.mnLayersClick(Sender: TObject);
var
  B: Boolean;
begin
  B := not ImgView.Bitmap.Empty;
  mnNewBitmapLayer.Enabled := B;
  mnNewBitmapRGBA.Enabled := B;
  mnNewCustomLayer.Enabled := B;
end;




procedure TSurfaces2Dform.ScaleComboChange(Sender: TObject);
var
  S: string;
  I: Integer;
begin
  S := ScaleCombo.Text;
  S := StringReplace(S, '%', '', [rfReplaceAll]);
  S := StringReplace(S, ' ', '', [rfReplaceAll]);
  if S = '' then Exit;
  I := StrToIntDef(S, -1);
  if (I < 1) or (I > 2000) then I := Round(ImgView.Scale * 100)
  else ImgView.Scale := I / 100;
  ScaleCombo.Text := IntToStr(I) + '%';
  ScaleCombo.SelStart := Length(ScaleCombo.Text) - 1;
end;


procedure TSurfaces2Dform.WMEraseBkgnd(var Msg: TMessage);
begin
  // disable form background cleaning
  Msg.Result := 1;
end;


procedure TSurfaces2Dform.RBMouseDown(Sender: TObject; Buttons: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
  // this event handler is called after the mouse button is pressed on top
  // of the rubber band layer
  with RBLayer do
    if ssCtrl in Shift then ResizeOptions := ResizeOptions + [rroSymmetrical]
    else ResizeOptions := ResizeOptions - [rroSymmetrical];

end;

{ ===================== }
{ F. OTT, rajouts }

procedure TSurfaces2Dform.PaintData;
var
  P: PPalette32;
begin

  case PaletteCombo.ItemIndex of
    0: P := @palGrayScale;
    1: P := @palGreens;
    2: P := @palReds;
    3: P := @palRainbow;
  else
    P := @palCustom;
  end;
  DataSet.WriteTo(ImgView.Bitmap, P^);
  ColorBar.writeTo(ColorScale.bitmap, P^);
{ ecriture des graduations  sur l'chelle de couleur}
{  ImgView.BitMap.TextOut(100, 100, 'toto') } { c'est nul; ca ecrit en bitmap }
{ cas d'une echelle lineaire }
if ZlogCheckBox.checked=false then
begin
   scale5.caption:=FloatToStrF(zmax,ffGeneral,1,3);
   scale1.caption:=FloatToStrF(zmin,ffGeneral,1,3);
   scale2.caption:=FloatToStrF((zmax-zmin)/4+zmin,ffGeneral,1,3);
   scale3.caption:=FloatToStrF((zmax+zmin)/2,ffGeneral,1,3);
   scale4.caption:=FloatToStrF(3*(zmax-zmin)/4+zmin,ffGeneral,1,3);
end;
if ZlogCheckBox.checked=true then
begin
   scale5.caption:=FloatToStrF(zmax,ffGeneral,1,3);
   scale1.caption:=FloatToStrF(zmin,ffGeneral,1,3);
   scale2.caption:=FloatToStrF(power(10,(log10(zmax)-log10(zmin))/4+log10(zmin)),ffGeneral,1,3);
   scale3.caption:=FloatToStrF(power(10,(log10(zmax)-log10(zmin))/2+log10(zmin)),ffGeneral,1,3);
   scale4.caption:=FloatToStrF(power(10,3*(log10(zmax)-log10(zmin))/4+log10(zmin)),ffGeneral,1,3);
end;

end;

procedure TSurfaces2Dform.Replot;
var i,j:integer;
begin
  if comboBoxDataSet.text='non polarised' then for i:=0 to Xmesh-1 do for j:=0 to Ymesh-1 do MesData3D[i,j]:=data3D_NP[i,j];
  if comboBoxDataSet.text='up-up' then for i:=0 to Xmesh-1 do for j:=0 to Ymesh-1 do MesData3D[i,j]:=data3D_UU[i,j];
  if comboBoxDataSet.text='do-do' then for i:=0 to Xmesh-1 do for j:=0 to Ymesh-1 do MesData3D[i,j]:=data3D_DD[i,j];
  GenSampleData(Xmesh, Ymesh);
  PaintData;
end;

procedure TSurfaces2Dform.Replot1Click(Sender: TObject);
var i,j:integer;
begin
     replot;
end;

procedure TSurfaces2Dform.ComboBoxDataSetChange(Sender: TObject);
begin
     replot;
end;


procedure TSurfaces2Dform.PaletteComboChange(Sender: TObject);
begin
     PaintData;
end;

procedure TSurfaces2Dform.ScaleBarChange(Sender: TObject);
var
  NewScale: Single;
begin
  NewScale := Power(10, (ScaleBar.Position) / 100);
  ScaleBar.Repaint;
  ImgView.ScaleMode := SmScale;
  ImgView.Scale := NewScale;
  CurrentScale:=NewScale;
end;

procedure TSurfaces2Dform.Stretch;
var
  NewScale1,NewScale2: Single;
begin
{ IL faut tenir compte de la taille des ascenseurs }
{ UTILISER GetViewPortRect                         }
  NewScale1:=abs(ImgView.GetViewPortRect.Left-ImgView.GetViewPortRect.Right)/Xmesh;
  NewScale2:=abs(ImgView.GetViewPortRect.Top-ImgView.GetViewPortRect.Bottom)/Ymesh;
  CurrentScale:=min(NewScale1,NewScale2);
  ImgView.Scale := CurrentScale;
  {  ImgView.ScaleMode := SmStretch;  } { ne fonctionne pas en ImgView32 ?!? }
end;

{ on va bricoler l'autostrech }
procedure TSurfaces2Dform.StretchButtonClick(Sender: TObject);
begin
     stretch;
end;

procedure TSurfaces2Dform.PaletteCenterGaugeBarChange(Sender: TObject);
var
  i: Integer;
  f: Single;
begin
  for i := 0 to 255 do
  begin
    f := i / 255;
    PalCustom[i]:= HSLtoRGB(0, 0, PaletteAmplitudeGaugeBar.position/100 * f + PaletteCenterGaugeBar.position/100);
  end;
  PaintData;
end;

procedure TSurfaces2Dform.PaletteAmplitudeGaugeBarChange(Sender: TObject);
var
  i: Integer;
  f: Single;
begin
  for i := 0 to 255 do
  begin
    f := i / 255;
    PalCustom[i]:= HSLtoRGB(0, 0, PaletteAmplitudeGaugeBar.position/100 * f + PaletteCenterGaugeBar.position/100);
  end;
  PaintData;
end;


procedure TSurfaces2Dform.CreateData3D1Click(Sender: TObject);
var i,j:integer;
begin
     Xmesh:=128;Ymesh:=128;
     setLength(MesData3D,Xmesh+1,Ymesh+1);
     xmin:=0;xmax:=128;ymin:=0;ymax:=128;
     for i:=0 to Xmesh do
         for j:=0 to Ymesh do MesData3D[i,j]:=power(10,(sin(i/12)*cos(j/12)));
     zmin:=-1;zmax:=+1;
end;

{ ================================= }
{ Partie pour le trac des curseurs }

procedure TSurfaces2Dform.Draw;
begin
  ImgView.Bitmap.BeginUpdate;
  ImgView.Bitmap.Clear(clWhite32);
{  ImgView.Bitmap.Draw(50, 50, BitmapList.Bitmaps[0].Bitmap); } { cette ligne ne marche pas }
{ on essaie ca }  PaintData;
  PolygonH1.Antialiased := false; {Antialiase.Checked; }
  PolygonV1.Antialiased := false; {Antialiase.Checked; }
  PolygonH1.DrawFill(ImgView.Bitmap, SetAlpha(clGreen32, 255));
  PolygonV1.DrawFill(ImgView.Bitmap, SetAlpha(clGreen32, 255));
  PolygonH1.DrawEdge(ImgView.Bitmap, SetAlpha(clMaroon32, 255));
  PolygonV1.DrawEdge(ImgView.Bitmap, SetAlpha(clRed32, 255));
  PolygonH2.Antialiased := false; {Antialiase.Checked; }
  PolygonV2.Antialiased := false; {Antialiase.Checked; }
  PolygonH2.DrawFill(ImgView.Bitmap, SetAlpha(clGreen32, 255));
  PolygonV2.DrawFill(ImgView.Bitmap, SetAlpha(clGreen32, 255));
  PolygonH2.DrawEdge(ImgView.Bitmap, SetAlpha(clNavy32, 255));
  PolygonV2.DrawEdge(ImgView.Bitmap, SetAlpha(clBlue32, 255));

  PolygonD.Antialiased := false; {Antialiase.Checked; }
  PolygonD.DrawEdge(ImgView.Bitmap, SetAlpha(clGreen32, 255));

  ImgView.Bitmap.EndUpdate;
  ImgView.Bitmap.Changed;
  ImgView.Refresh; // force repaint
end;

procedure TSurfaces2Dform.Zval1Change(Sender: TObject);
begin

end;

{ procedure pour mettre  jour les champs des courbes a afficher }
procedure TSurfaces2Dform.UpdateCourbesAafficher;
begin
  if (typeGraphCombo.text='Horizontales')
  then begin
       xyCoupe[CoupeHorz1].active:=true;
       xyCoupe[CoupeHorz2].active:=true;
       xyCoupe[CoupeVert1].active:=false;
       xyCoupe[CoupeVert2].active:=false;
       xyCoupe[CoupeDiagX].active:=false;
       xyCoupe[CoupeDiagY].active:=false;
       xyCoupe[CoupeDiagP45].active:=false;
       xyCoupe[CoupeDiagM45].active:=false;
       end;
  if (typeGraphCombo.text='Curseur 1')
  then begin
       xyCoupe[CoupeHorz1].active:=true;
       xyCoupe[CoupeHorz2].active:=false;
       xyCoupe[CoupeVert1].active:=true;
       xyCoupe[CoupeVert2].active:=false;
       xyCoupe[CoupeDiagX].active:=false;
       xyCoupe[CoupeDiagY].active:=false;
       xyCoupe[CoupeDiagP45].active:=false;
       xyCoupe[CoupeDiagM45].active:=false;
       end;
  if (typeGraphCombo.text='Verticales')
  then begin
       xyCoupe[CoupeHorz1].active:=false;
       xyCoupe[CoupeHorz2].active:=false;
       xyCoupe[CoupeVert1].active:=true;
       xyCoupe[CoupeVert2].active:=true;
       xyCoupe[CoupeDiagX].active:=false;
       xyCoupe[CoupeDiagY].active:=false;
       xyCoupe[CoupeDiagP45].active:=false;
       xyCoupe[CoupeDiagM45].active:=false;
       end;
  if (typeGraphCombo.text='Curseur 2')
  then begin
       xyCoupe[CoupeHorz1].active:=false;
       xyCoupe[CoupeHorz2].active:=true;
       xyCoupe[CoupeVert1].active:=false;
       xyCoupe[CoupeVert2].active:=true;
       xyCoupe[CoupeDiagX].active:=false;
       xyCoupe[CoupeDiagY].active:=false;
       xyCoupe[CoupeDiagP45].active:=false;
       xyCoupe[CoupeDiagM45].active:=false;
       end;
  if (typeGraphCombo.text='DiagonaleX')
  then begin
       xyCoupe[CoupeHorz1].active:=false;
       xyCoupe[CoupeHorz2].active:=false;
       xyCoupe[CoupeVert1].active:=false;
       xyCoupe[CoupeVert2].active:=false;
       xyCoupe[CoupeDiagX].active:=true;
       xyCoupe[CoupeDiagY].active:=false;
       xyCoupe[CoupeDiagP45].active:=false;
       xyCoupe[CoupeDiagM45].active:=false;
  end;
  if (typeGraphCombo.text='DiagonaleY')
  then begin
       xyCoupe[CoupeHorz1].active:=false;
       xyCoupe[CoupeHorz2].active:=false;
       xyCoupe[CoupeVert1].active:=false;
       xyCoupe[CoupeVert2].active:=false;
       xyCoupe[CoupeDiagX].active:=false;
       xyCoupe[CoupeDiagY].active:=true;
       xyCoupe[CoupeDiagP45].active:=false;
       xyCoupe[CoupeDiagM45].active:=false;
       end;
  if (typeGraphCombo.text='Diagonale +45')
  then begin
       xyCoupe[CoupeHorz1].active:=false;
       xyCoupe[CoupeHorz2].active:=false;
       xyCoupe[CoupeVert1].active:=false;
       xyCoupe[CoupeVert2].active:=false;
       xyCoupe[CoupeDiagX].active:=false;
       xyCoupe[CoupeDiagY].active:=false;
       xyCoupe[CoupeDiagP45].active:=true;
       xyCoupe[CoupeDiagM45].active:=false;
       end;
  if (typeGraphCombo.text='Diagonale -45')
  then begin
       xyCoupe[CoupeHorz1].active:=false;
       xyCoupe[CoupeHorz2].active:=false;
       xyCoupe[CoupeVert1].active:=false;
       xyCoupe[CoupeVert2].active:=false;
       xyCoupe[CoupeDiagX].active:=false;
       xyCoupe[CoupeDiagY].active:=false;
       xyCoupe[CoupeDiagP45].active:=false;
       xyCoupe[CoupeDiagM45].active:=true;
       end;
end;

{ changement des courbes a afficher  dans le graph1D }
{ en fonction de ce qui est demand dans la combobox }
procedure TSurfaces2Dform.TypeGraphComboChange(Sender: TObject);
begin
  UpdateCourbesAafficher
end;

procedure TSurfaces2Dform.ZminBoxExit(Sender: TObject);
begin
   zmin:=zminbox.value;zmax:=zmaxbox.value;
   GenSampleData(Xmesh, Ymesh);
   PaintData;
end;

procedure TSurfaces2Dform.ZmaxBoxExit(Sender: TObject);
begin
   zmin:=zminbox.value;zmax:=zmaxbox.value;
   GenSampleData(Xmesh, Ymesh);
   PaintData;
end;

procedure TSurfaces2Dform.ZlogCheckBoxClick(Sender: TObject);
begin
     if (zmin>0) and (zmax>0)
     then begin
          GenSampleData(Xmesh, Ymesh);PaintData;
          end
     else begin
          ZlogCheckBox.checked:=false;ZlogCheckBox.update;
          MessageDlg('You need a positive Z range',mtError,[mbOk],0);
          end;
end;

procedure TSurfaces2Dform.ZmaxBoxKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
     if key=13 then
     begin zmin:=zminbox.value;zmax:=zmaxbox.value;GenSampleData(Xmesh, Ymesh);PaintData; end;
     if (key=38) then begin ZmaxBox.value:=ZmaxBox.value*10;
                          zmin:=zminbox.value;zmax:=zmaxbox.value;GenSampleData(Xmesh, Ymesh);PaintData;
                          end;
     if (key=40) and (ZmaxBox.value>(ZminBox.value*11)) then begin ZmaxBox.value:=ZmaxBox.value/10;
                          zmin:=zminbox.value;zmax:=zmaxbox.value;GenSampleData(Xmesh, Ymesh);PaintData;
                          end;
end;

procedure TSurfaces2Dform.ZminBoxKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
     if key=13 then
     begin zmin:=zminbox.value;zmax:=zmaxbox.value;GenSampleData(Xmesh, Ymesh);PaintData; end;
     if (key=38) and (ZminBox.value<(ZmaxBox.value/11)) then begin ZminBox.value:=ZminBox.value*10;
                          zmin:=zminbox.value;zmax:=zmaxbox.value;GenSampleData(Xmesh, Ymesh);PaintData;
                          end;
     if key=40 then begin ZminBox.value:=ZminBox.value/10;
                          zmin:=zminbox.value;zmax:=zmaxbox.value;GenSampleData(Xmesh, Ymesh);PaintData;
                          end;
end;

procedure TSurfaces2Dform.AutoScaleButtonClick(Sender: TObject);
var i,j:integer;
    zzmin,zzmax:double;
begin
     zzmin:=+1e38;zzmax:=-1e-38;
     for i:=0 to Xmesh-1 do
         for j:=0 to Ymesh-1 do
         begin
              if MesData3D[i,j]>zzmax then zzmax:=MesData3D[i,j];
              if MesData3D[i,j]<zzmin then zzmin:=MesData3D[i,j]
         end;
     zmin:=zzmin;zminbox.value:=zmin;
     zmax:=zzmax;zmaxbox.value:=zmax;
     GenSampleData(Xmesh, Ymesh);
     PaintData;
end;

procedure TSurfaces2Dform.Z1DMinBoxKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
     if key=13 then begin XYcoupe.YAxis.min:=Z1DMinbox.value;xycoupe.update;  end;
     if key=38 then begin Z1DminBox.value:=Z1DminBox.value*10;
                          XYcoupe.YAxis.min:=Z1DMinbox.value;xycoupe.update;
                          end;
     if key=40 then begin Z1DminBox.value:=Z1DminBox.value/10;
                          XYcoupe.YAxis.min:=Z1DMinbox.value;xycoupe.update;
                          end;
end;

procedure TSurfaces2Dform.Z1DMaxBoxKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
     if key=13 then begin XYcoupe.YAxis.max:=Z1DMaxBox.value;xycoupe.update;  end;
     if key=38 then begin Z1DmaxBox.value:=Z1DmaxBox.value*10;
                          XYcoupe.YAxis.max:=Z1DMaxBox.value;xycoupe.update;
                          end;
     if key=40 then begin Z1DmaxBox.value:=Z1DmaxBox.value/10;
                          XYcoupe.YAxis.max:=Z1DMaxBox.value;xycoupe.update;
                          end;
end;

procedure TSurfaces2Dform.Z1DLogCheckBoxClick(Sender: TObject);
begin
     if (Z1DLogCheckBox.checked=true)
     then begin
          if Z1DMinBox.value<0 then begin Z1DMinBox.value:=Z1DMaxBox.value/10;zmin:=Z1DMinBox.value;XYcoupe.YAxis.min:=zmin end;
          XYcoupe.YAxis.Logscale:=true;xycoupe.update
          end
     else begin XYcoupe.YAxis.Logscale:=false;xycoupe.update; end;

end;

procedure TSurfaces2Dform.SaveMenuClick(Sender: TObject);
begin
  IF   SavePictureDialog.Execute
  THEN ImgView.Bitmap.SaveToFile(SavePictureDialog.Filename) 
end;

end.
